/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the JObjectBulkOperationResultEnumerateEnvelope type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JObjectBulkOperationResultEnumerateEnvelope{}

// JObjectBulkOperationResultEnumerateEnvelope struct for JObjectBulkOperationResultEnumerateEnvelope
type JObjectBulkOperationResultEnumerateEnvelope struct {
	Pagination *Pagination                  `json:"pagination,omitempty"`
	Delta      *Delta                       `json:"delta,omitempty"`
	RequestId  NullableString               `json:"request_id,omitempty"`
	Message    NullableString               `json:"message,omitempty"`
	Data       []JObjectBulkOperationResult `json:"data,omitempty"`
}

// NewJObjectBulkOperationResultEnumerateEnvelope instantiates a new JObjectBulkOperationResultEnumerateEnvelope object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJObjectBulkOperationResultEnumerateEnvelope() *JObjectBulkOperationResultEnumerateEnvelope {
	this := JObjectBulkOperationResultEnumerateEnvelope{}
	return &this
}

// NewJObjectBulkOperationResultEnumerateEnvelopeWithDefaults instantiates a new JObjectBulkOperationResultEnumerateEnvelope object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJObjectBulkOperationResultEnumerateEnvelopeWithDefaults() *JObjectBulkOperationResultEnumerateEnvelope {
	this := JObjectBulkOperationResultEnumerateEnvelope{}
	return &this
}

// GetPagination returns the Pagination field value if set, zero value otherwise.
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetPagination() Pagination {
	if o == nil || IsNil(o.Pagination) {
		var ret Pagination
		return ret
	}
	return *o.Pagination
}

// GetPaginationOk returns a tuple with the Pagination field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetPaginationOk() (*Pagination, bool) {
	if o == nil || IsNil(o.Pagination) {
		return nil, false
	}
	return o.Pagination, true
}

// HasPagination returns a boolean if a field has been set.
func (o *JObjectBulkOperationResultEnumerateEnvelope) HasPagination() bool {
	if o != nil && !IsNil(o.Pagination) {
		return true
	}

	return false
}

// SetPagination gets a reference to the given Pagination and assigns it to the Pagination field.
func (o *JObjectBulkOperationResultEnumerateEnvelope) SetPagination(v Pagination) {
	o.Pagination = &v
}

// GetDelta returns the Delta field value if set, zero value otherwise.
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetDelta() Delta {
	if o == nil || IsNil(o.Delta) {
		var ret Delta
		return ret
	}
	return *o.Delta
}

// GetDeltaOk returns a tuple with the Delta field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetDeltaOk() (*Delta, bool) {
	if o == nil || IsNil(o.Delta) {
		return nil, false
	}
	return o.Delta, true
}

// HasDelta returns a boolean if a field has been set.
func (o *JObjectBulkOperationResultEnumerateEnvelope) HasDelta() bool {
	if o != nil && !IsNil(o.Delta) {
		return true
	}

	return false
}

// SetDelta gets a reference to the given Delta and assigns it to the Delta field.
func (o *JObjectBulkOperationResultEnumerateEnvelope) SetDelta(v Delta) {
	o.Delta = &v
}

// GetRequestId returns the RequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetRequestId() string {
	if o == nil || IsNil(o.RequestId.Get()) {
		var ret string
		return ret
	}
	return *o.RequestId.Get()
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RequestId.Get(), o.RequestId.IsSet()
}

// HasRequestId returns a boolean if a field has been set.
func (o *JObjectBulkOperationResultEnumerateEnvelope) HasRequestId() bool {
	if o != nil && o.RequestId.IsSet() {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given NullableString and assigns it to the RequestId field.
func (o *JObjectBulkOperationResultEnumerateEnvelope) SetRequestId(v string) {
	o.RequestId.Set(&v)
}

// SetRequestIdNil sets the value for RequestId to be an explicit nil
func (o *JObjectBulkOperationResultEnumerateEnvelope) SetRequestIdNil() {
	o.RequestId.Set(nil)
}

// UnsetRequestId ensures that no value is present for RequestId, not even an explicit nil
func (o *JObjectBulkOperationResultEnumerateEnvelope) UnsetRequestId() {
	o.RequestId.Unset()
}

// GetMessage returns the Message field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetMessage() string {
	if o == nil || IsNil(o.Message.Get()) {
		var ret string
		return ret
	}
	return *o.Message.Get()
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetMessageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Message.Get(), o.Message.IsSet()
}

// HasMessage returns a boolean if a field has been set.
func (o *JObjectBulkOperationResultEnumerateEnvelope) HasMessage() bool {
	if o != nil && o.Message.IsSet() {
		return true
	}

	return false
}

// SetMessage gets a reference to the given NullableString and assigns it to the Message field.
func (o *JObjectBulkOperationResultEnumerateEnvelope) SetMessage(v string) {
	o.Message.Set(&v)
}

// SetMessageNil sets the value for Message to be an explicit nil
func (o *JObjectBulkOperationResultEnumerateEnvelope) SetMessageNil() {
	o.Message.Set(nil)
}

// UnsetMessage ensures that no value is present for Message, not even an explicit nil
func (o *JObjectBulkOperationResultEnumerateEnvelope) UnsetMessage() {
	o.Message.Unset()
}

// GetData returns the Data field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetData() []JObjectBulkOperationResult {
	if o == nil {
		var ret []JObjectBulkOperationResult
		return ret
	}
	return o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JObjectBulkOperationResultEnumerateEnvelope) GetDataOk() ([]JObjectBulkOperationResult, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *JObjectBulkOperationResultEnumerateEnvelope) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given []JObjectBulkOperationResult and assigns it to the Data field.
func (o *JObjectBulkOperationResultEnumerateEnvelope) SetData(v []JObjectBulkOperationResult) {
	o.Data = v
}

func (o JObjectBulkOperationResultEnumerateEnvelope) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JObjectBulkOperationResultEnumerateEnvelope) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Pagination) {
		toSerialize["pagination"] = o.Pagination
	}
	if !IsNil(o.Delta) {
		toSerialize["delta"] = o.Delta
	}
	if o.RequestId.IsSet() {
		toSerialize["request_id"] = o.RequestId.Get()
	}
	if o.Message.IsSet() {
		toSerialize["message"] = o.Message.Get()
	}
	if o.Data != nil {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableJObjectBulkOperationResultEnumerateEnvelope struct {
	value *JObjectBulkOperationResultEnumerateEnvelope
	isSet bool
}

func (v NullableJObjectBulkOperationResultEnumerateEnvelope) Get() *JObjectBulkOperationResultEnumerateEnvelope {
	return v.value
}

func (v *NullableJObjectBulkOperationResultEnumerateEnvelope) Set(val *JObjectBulkOperationResultEnumerateEnvelope) {
	v.value = val
	v.isSet = true
}

func (v NullableJObjectBulkOperationResultEnumerateEnvelope) IsSet() bool {
	return v.isSet
}

func (v *NullableJObjectBulkOperationResultEnumerateEnvelope) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJObjectBulkOperationResultEnumerateEnvelope(val *JObjectBulkOperationResultEnumerateEnvelope) *NullableJObjectBulkOperationResultEnumerateEnvelope {
	return &NullableJObjectBulkOperationResultEnumerateEnvelope{value: val, isSet: true}
}

func (v NullableJObjectBulkOperationResultEnumerateEnvelope) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJObjectBulkOperationResultEnumerateEnvelope) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
